package testutil

import (
	"math/bits"
	"runtime"
	"testing"
)

func Skip32bit(t *testing.T) {
	t.Helper()

	if bits.UintSize == 32 {
		t.Skip("Skipping test on 32-bit arch")
	}
}

func SkipSlow(t *testing.T) {
	t.Helper()
	SkipOn(t, []string{"386", "arm", "mipsle", "riscv64"}, "Skipping CPU-intensive test on slow arch")
}

func SkipOn(t *testing.T, arches []string, msg string) {
	t.Helper()

	for _, arch := range arches {
		if runtime.GOARCH == arch {
			t.Skip(msg)
		}
	}
}
